## ros-melodic-iris-lama 1.1.0

=== src/CMakeLists.txt ===

set(lama_SOURCES
    pose2d.cpp
    pose3d.cpp
    print.cpp
    buffer_compressor.cpp
    random.cpp
    image_io.cpp
    thread_pool.cpp
    # Non-Linear Least Squares Optimization
    nlls/solver.cpp
    nlls/robust_cost.cpp
    nlls/gauss_newton.cpp
    nlls/levenberg_marquardt.cpp
    # Sparse-Dense Mapping
    sdm/container.cpp
    sdm/map.cpp
    sdm/dynamic_distance_map.cpp
    sdm/simple_occupancy_map.cpp
    sdm/frequency_occupancy_map.cpp
    sdm/probabilistic_occupancy_map.cpp
    sdm/truncated_signed_distance_map.cpp
    sdm/marching_cubes.cpp
    sdm/export.cpp
    # Lossless data compression
    extern/lz4.c
    extern/zstd/entropy_common.c
    extern/zstd/fse_decompress.c
    extern/zstd/threading.c
    extern/zstd/pool.c
    extern/zstd/zstd_common.c
    extern/zstd/error_private.c
    extern/zstd/debug.c
    extern/zstd/fse_compress.c
    extern/zstd/huf_compress.c
    extern/zstd/zstd_compress.c
    extern/zstd/zstdmt_compress.c
    extern/zstd/zstd_fast.c
    extern/zstd/zstd_double_fast.c
    extern/zstd/zstd_lazy.c
    extern/zstd/zstd_opt.c
    extern/zstd/zstd_ldm.c
    extern/zstd/hist.c
    extern/zstd/huf_decompress.c
    extern/zstd/zstd_decompress.c
    extern/zstd/zstd_ddict.c
    # Localization and Mapping
    match_surface_2d.cpp
    loc2d.cpp
    slam2d.cpp
    pf_slam2d.cpp
)

add_library(${PROJECT_NAME} ${lama_SOURCES})
target_compile_options(${PROJECT_NAME} PRIVATE -Wall)

if(COMPILING_WITH_CATKIN)
    install(TARGETS ${PROJECT_NAME}
      ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
      LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
      RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION}
    )
    install(DIRECTORY ../include/lama/
      DESTINATION ${CATKIN_GLOBAL_INCLUDE_DESTINATION}/lama
      PATTERN ".svn" EXCLUDE
    )
elseif(COMPILING_WITH_AMENT)
    install(TARGETS ${PROJECT_NAME}
        ARCHIVE DESTINATION lib
        LIBRARY DESTINATION lib
        RUNTIME DESTINATION lib
        INCLUDES DESTINATION include)
    install(DIRECTORY ../include/lama/
        DESTINATION include/lama
        PATTERN ".svn" EXCLUDE)
else()
    export(TARGETS ${PROJECT_NAME} FILE iris_lamaConfig.cmake)
    set(CMAKE_EXPORT_PACKAGE_REGISTRY ON)
    export(PACKAGE iris_lama)
endif()

=== debian/changelog ===
ros-melodic-iris-lama (1.1.0-2stretch) stretch; urgency=high

  * Expose the global localization parameters as options
  * Add option to mark free cells when there is no hit in SLAM (i.e. truncated ranges)
  * Add non-motion update trigger to location
  * Fix infinite loop in global localization
  * Use C++14
  * Fix eigen aligment issues

 -- Eurico Pedrosa <efp@ua.pt>  Sat, 05 Dec 2020 00:00:00 -0000

ros-melodic-iris-lama (1.0.0-2stretch) stretch; urgency=high

  * First official release.

 -- Eurico Pedrosa <efp@ua.pt>  Tue, 05 May 2020 00:00:00 -0000

=== debian/control ===
Source: ros-melodic-iris-lama
Section: misc
Priority: optional
Maintainer: Eurico Pedrosa <efp@ua.pt>
Build-Depends: debhelper (>= 9.0.0), libeigen3-dev, ros-melodic-catkin
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-iris-lama
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev
Description: IRIS package for Localization and Mapping (LaMa).
 This packages includes the sparse-dense library for grid mapping, a 2D localization algorithm based on scan matching, an online SLAM solution with a dynamic likelihood field and a 2D RB Particle Filter SLAM solution with multithreading.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-iris-lama//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install

## ros-melodic-iris-lama 1.2.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(iris_lama LANGUAGES CXX C)

# http://answers.ros.org/question/230877/optionally-build-a-package-with-catkin/
if( CATKIN_DEVEL_PREFIX OR catkin_FOUND OR CATKIN_BUILD_BINARY_PACKAGE)
    set(COMPILING_WITH_CATKIN 1)
elseif( DEFINED ENV{AMENT_PREFIX_PATH})
        set(COMPILING_WITH_AMENT 1)
endif()

set(CMAKE_CXX_STANDARD 14) # use c++14

find_package(Eigen 3 QUIET)
if(NOT Eigen_FOUND)
  include(${PROJECT_SOURCE_DIR}/cmake/FindEigen3.cmake)
  set(Eigen_INCLUDE_DIR "${EIGEN3_INCLUDE_DIR}")
endif()

# Default to release mode.
if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release)
endif()

if(COMPILING_WITH_CATKIN)
    message(STATUS "---------------")
    message(STATUS "Catkin detected")
    message(STATUS "---------------")

    find_package(catkin REQUIRED)
    catkin_package(
        INCLUDE_DIRS include
        LIBRARIES ${PROJECT_NAME}
        )
elseif(COMPILING_WITH_AMENT)
    message(STATUS "--------------")
    message(STATUS "Ament detected")
    message(STATUS "--------------")

    find_package(ament_cmake REQUIRED)
    ament_export_include_directories(include)
    ament_export_libraries(${PROJECT_NAME})
endif()

INCLUDE_DIRECTORIES(include ${Eigen_INCLUDE_DIR})
add_subdirectory(src)

if(COMPILING_WITH_AMENT)
    ament_package()
    # for some reason this variable is set and cmake complains it is not used.
    unset( CATKIN_INSTALL_INTO_PREFIX_ROOT )
endif()

=== debian/changelog ===
ros-melodic-iris-lama (1.2.0-1bionic) bionic; urgency=high

  * Expose localization covariance

 -- Eurico Pedrosa <efp@ua.pt>  Fri, 09 Apr 2021 23:00:00 -0000

ros-melodic-iris-lama (1.1.0-1bionic) bionic; urgency=high

  * Expose the global localization parameters as options
  * Add option to mark free cells when there is no hit in SLAM (i.e. truncated ranges)
  * Add non-motion update trigger to location
  * Fix infinite loop in global localization
  * Use C++14
  * Fix eigen aligment issues

 -- Eurico Pedrosa <efp@ua.pt>  Sat, 05 Dec 2020 00:00:00 -0000

ros-melodic-iris-lama (1.0.0-1bionic) bionic; urgency=high

  * First official release.

 -- Eurico Pedrosa <efp@ua.pt>  Mon, 04 May 2020 23:00:00 -0000
